Unit AST1R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTAFSI_p;

procedure AST1R(var A :Array of Real; M :Integer; N :Integer;
                var B :Array of Real; LTR :Integer; LOW :Integer;
                var IERR :Integer);

implementation

procedure AST1R(var A :Array of Real; M :Integer; N :Integer;
                var B :Array of Real; LTR :Integer; LOW :Integer;
                var IERR :Integer);
var
I,I0,I1,JJ,K,KB,LM :Integer;
S,T :Real;
LOWER :Boolean;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130,_140,_150,
_160,_170,_180,_190,_200,_210;
begin
{ ********************************************************************C }
{   PEEHE CCTEM A*X=B  TRANS(A)*X=B C TPEYOHO MATPE A.  C }
{ ********************************************************************C }

{   YCTAHOBEHE KOHTPO HA BOMOHOCT EPEOHEH }
S  := 0.0;
_10:

{   POBEPKA PABHOCT AAH APAMETPOB M  N }
if ( N  >=  1 ) and (  M  >=  1 ) 
 then goto _20;
IERR  := 65;
UTAFSI('A','S','T','1','R',IERR);
goto _210;
_20:
IERR  := 0;
LOWER  := ( LOW  <>  0 );
for I:=1 to N do
 begin
  if ( A[(I-1)+(I-1)*M] <>  0.0 ) 
   then goto _30;
  IERR  := -I;
_30:
_40:
 end;
if ( IERR  <>  0 ) 
 then UTAFSI('A','S','T','1','R',IERR);
if ( LTR  <>  0 ) 
 then goto _130;

{   PEEHE CCTEM A*X=B }
for KB:=1 to N do
 begin
  K  := N + 1 - KB;
  if ( LOWER ) 
   then K  := KB;
  if ( A[(K-1)+(K-1)*M] <>  0.0 ) 
   then goto _60;
  if ( B[K-1] <>  0.0 ) 
   then goto _50;
  B[K-1] := 1.0;
  goto _70;
_50:
  IERR  := 67;
  UTAFSI('A','S','T','1','R',IERR);
  goto _210;
_60:
  B[K-1] := B[K-1]/A[(K-1)+(K-1)*M];
_70:
  T  := B[K-1];
  if ( KB  >=  N ) 
   then goto _110;
  I0  := 1;
  if ( LOWER ) 
   then I0  := K + 1;
  LM  := N - KB;
  I1  := I0 + LM - 1;
  I  := ((LM) Mod (4)) + I0 - 1;
  if ( I  <  I0 ) 
   then goto _90;
  for JJ:=I0 to I do
   begin
    B[JJ-1] := B[JJ-1] - T*A[(JJ-1)+(K-1)*M];
_80:
   end;
_90:
  I  := I + 1;
  if ( I  >  I1 ) 
   then goto _110;
  JJ := I;
  while ( JJ<=I1 ) do
   begin
    B[JJ-1] := B[JJ-1] - T*A[(JJ-1)+(K-1)*M];
    B[JJ+0] := B[JJ+0] - T*A[(JJ+0)+(K-1)*M];
    B[JJ+1] := B[JJ+1] - T*A[(JJ+1)+(K-1)*M];
    B[JJ+2] := B[JJ+2] - T*A[(JJ+2)+(K-1)*M];
_100:
    inc(JJ,4);
   end;
_110:
_120:
 end;
goto _210;

{   PEEHE CCTEM TRANS(A)*X=B }
_130:
for KB:=1 to N do
 begin
  K  := KB;
  if ( LOWER ) 
   then K  := N + 1 - KB;
  T  := 0.0;
  if ( KB  <=  1 ) 
   then goto _170;
  I0  := 1;
  if ( LOWER ) 
   then I0  := K + 1;
  LM  := KB - 1;
  I1  := I0 + LM - 1;
  I  := ((LM) Mod (5)) + I0 - 1;
  if ( I  <  I0 ) 
   then goto _150;
  for JJ:=I0 to I do
   begin
    T  := T + A[(JJ-1)+(K-1)*M]*B[JJ-1];
_140:
   end;
_150:
  I  := I + 1;
  if ( I  >  I1 ) 
   then goto _170;
  JJ := I;
  while ( JJ<=I1 ) do
   begin
    T  := T + A[(JJ-1)+(K-1)*M]*B[JJ-1] + A[(JJ+0)+(K-1)*M]*B[JJ+0] +
    A[(JJ+1)+(K-1)*M]*B[JJ+1] + A[(JJ+2)+(K-1)*M]*B[JJ+2] +
    A[(JJ+3)+(K-1)*M]*B[JJ+3];
_160:
    inc(JJ,5);
   end;
_170:
  if ( A[(K-1)+(K-1)*M] <>  0.0 ) 
   then goto _190;
  if ( (B[K-1] - T) <>  0.0 ) 
   then goto _180;
  B[K-1] := 1.0;
  goto _200;
_180:
  IERR  := 67;
  UTAFSI('A','S','T','1','R',IERR);
  goto _210;
_190:
  B[K-1] := (B[K-1] - T)/A[(K-1)+(K-1)*M];
_200:
 end;
_210:
end;

end.
